#include <stdio.h>
#include <stdlib.h>
#include "gauss.h"
#include "pd.h"
#include "draw.h"

#define VSWAP(i) { int _i; for (_i = 0; _i < i; _i++) m[mn][_i] = I; \
      m[mn][_i++] = V; for (; _i < nedges - 1; _i++) m[mn][_i] = I; \
      m[mn][_i++] = END; \
      /*m[mn] = realloc(m[mn], (_i + 1) * sizeof(move));*/ mn++; \
      _i = edges[i]; edges[i] = edges[i + 1]; edges[i + 1] = _i; }

// TODO: handle X(a,b,c,c) by connecting c and c automatically with I2 maybe
move **layout(PD p) {
  if (p.n == 0) {
    move **m = malloc(2 * sizeof(move *));
    m[0] = malloc(2 * sizeof(move));
    m[0][0] = C;
    m[0][1] = END;
    m[1] = malloc(sizeof(move));
    m[1][0] = END;
    return m;
  }
  move **m = malloc(10 * p.n * sizeof(move *)); // more than enough
  int i, j, k;
  for (i = 0; i < 10 * p.n; i++)
    m[i] = malloc((2 * p.n + 1) * sizeof(move));
  int edges[2 * p.n], nedges = 4; // currently free edges; counter-clockwise
  m[0][0] = X02;
  m[0][1] = END;
  m[0] = realloc(m[0], 2 * sizeof(move));
  for (i = 0; i < 4; i++)
    edges[i] = p.crossings[0][i];
  int mn = 1, used[p.n], nused = 1;
  used[0] = 1; // used crossings
  for (i = 1; i < p.n; i++)
    used[i] = 0;

  for (; nused < p.n; nused++) {
    int best, bv = 9, be = 0; // choose the best crossing to use next
    int x2ivj = 0;
    for (i = 0; i < p.n; i++)
      if (!used[i]) {
	int e = 0, last = 0, plast, v = 0;
	for (j = 0; j < 4; j++) // how many edges are shared
	  for (k = 0; k < nedges; k++)
	    if (p.crossings[i][j] == edges[k]) {
	      e++;
	      if (k > last) {
		last = k;
		plast = j;
	      }
	      break;
	    }
	if (e == 0)
	  continue;
	for (j = 0; j < e; j++)
	  if (p.crossings[i][(plast + j) % 4] != edges[last - j])
	    v = 1; // at best, a wrap-around is possible
	if (v == 1) { // try for wrap-around
	  if (last == nedges - 1) {
	    for (last = 0; last < nedges; last++) {
	      int found = 0;
	      for (k = 0; k < 4; k++)
		if (p.crossings[i][k] == edges[last]) {
		  found = 1;
		  plast = k;
		  break;
		}
	      if (found == 0)
	      break;
	    }
	    if (last != 0) {
	      last--;
	      for (j = 0; j < e; j++)
		if (p.crossings[i][(plast + j) % 4]
		    != edges[(last - j + nedges) % nedges])
		  v = 2; // no wrap-around possible, so virtual crossing needed
	    } else {
	      last = nedges - 1;
	      v = 2;
	    }
	  } else
	    v = 2;
	}
	if (v == 2) { // ideally, the connecting edges are at least adjacent
	  for (j = 0; j < e; j++) {
	    int found = 0;
	    for (k = 0; k < 4; k++)
	      if (last - j >= 0 && p.crossings[i][k] == edges[last - j]) {
		// (since wrap-arounds are not implemented for v == 2)
	      //if (p.crossings[i][k] == edges[(last - j + nedges) % nedges]) {
		found = 1;
		break;
	      }
	    if (found == 0) {
	      v = 3; // other edges must be moved out of the way
	      break;
	    }
	  }
	}
	if (v < bv || (v == bv && e > be)) {
	  best = i;
	  bv = v;
	  be = e;
	}
      }

    // now, the best crossing to use is best, and it connects to be edges
    if (bv == 1) { // do the wrap-around, then it's the regular best case
      // want to find which side (left or right) has more connecting edges
      int left = 0, right = 0;
      for (i = 0; i < nedges; i++) {
	int found = 0;
	for (j = 0; j < 4; j++)
	  if (edges[i] == p.crossings[best][j]) {
	    left++;
	    found = 1;
	    break;
	  }
	if (found == 0)
	  break;
      }
      for (i = nedges - 1; i >= 0; i--) {
	int found = 0;
	for (j = 0; j < 4; j++)
	  if (edges[i] == p.crossings[best][j]) {
	    right++;
	    found = 1;
	    break;
	  }
	if (found == 0)
	  break;
      }
      int oldedges[nedges];
      memcpy(oldedges, edges, nedges * sizeof(int));
      if (right < left) {
	for (i = 0; i < nedges - right; i++)
	  m[mn][i] = I;
	for (; i < nedges; i++)
	  m[mn][i] = WR;
	for (j = 0; j < right; j++)
	  edges[j] = oldedges[nedges - right + j];
	for (; j < nedges; j++)
	  edges[j] = oldedges[j - right];
      } else {
	for (i = 0; i < left; i++)
	    m[mn][i] = WL;
	for (; i < nedges; i++)
	  m[mn][i] = I;
	for (j = 0; j < nedges - left; j++)
	  edges[j] = oldedges[j + left];
	for (; j < nedges; j++)
	  edges[j] = oldedges[j - nedges + left];
	}
      m[mn][i] = END;
      //m[mn] = realloc(m[mn], (i + 1) * sizeof(move));
      mn++;
    } else if (bv == 3) { // desired edges are not grouped together
      int edgepos[be]; // which edges connect to the crossing
      for (i = 0, j = 0; i < nedges && j < be; i++)
	for (k = 0; k < 4; k++)
	  if (edges[i] == p.crossings[best][k]) {
	    edgepos[j++] = i;
	    break;
	  }
      int bestedge, bestcount = 5 * p.n; // want to minimize V. crossings
      int wrap[be], bwrap[be]; // whether or not to wrap-around
      // TODO: consider using wrap-arounds to better minimize V. crossings
      for (i = 0; i < be; i++) {
	int count = 0;
	for (j = 0; j < be; j++) {
	  int direct = abs(edgepos[j] - edgepos[i]);
	  int wrapn = nedges - direct;
	  //count += abs(edgepos[j] - edgepos[i]);
	  count += direct < wrapn ? direct : wrapn;
	  wrap[j] = wrapn < direct;
	}
	if (count < bestcount) {
	  bestcount = count;
	  bestedge = i;
	  memcpy(bwrap, wrap, be * sizeof(int));
	}
      }
      // do any necessary wrap-arounds
      for (i = 0; i < bestedge && bwrap[i]; i++) // first try on the left
	for (; edgepos[i] > 0 && edgepos[i] != edgepos[i-1] + 1; edgepos[i]--)
	  VSWAP(edgepos[i] - 1);
      if (i > 0) { // do the wrap-arounds
	//DEBUG:
	/*printf("before WL: ");
	for (j = 0; j < nedges; j++)
	  printf("%d ", edges[j]);
	  printf("\n");*/
	//END DEBUG
	for (j = 0; j < i; j++)
	  m[mn][j] = WL;
	for (; j < nedges; j++)
	  m[mn][j] = I;
	m[mn++][j] = END;
	int oldedges[nedges];
	memcpy(oldedges, edges, nedges * sizeof(int));
	for (j = 0; j < nedges - i; j++)
	  edges[j] = oldedges[j + i];
	for (; j < nedges; j++)
	  edges[j] = oldedges[j - nedges + i];
	memcpy(oldedges, edgepos, be * sizeof(int));
	for (j = 0; j < be - i; j++)
	  edgepos[j] = oldedges[j + i] - i;
	for (; j < be; j++)
	  edgepos[j] = oldedges[j - be + i] + nedges - i;
	bestedge -= i;
	//DEBUG:
	/*printf("after WL: ");
	for (j = 0; j < nedges; j++)
	  printf("%d ", edges[j]);
	  printf("\n");*/
	//END DEBUG
      } else {
	for (i = be - 1; i > bestedge && bwrap[i]; i--) // now try on the right
	  for (; edgepos[i] < nedges - 1 && edgepos[i] != edgepos[i + 1] - 1;
	       edgepos[i]++)
	    VSWAP(edgepos[i]);
	if (i < be - 1) { // do wrap-arounds
	//DEBUG:
	/*printf("before WR: ");
	for (j = 0; j < nedges; j++)
	  printf("%d ", edges[j]);
	  printf("\n");*/
	//END DEBUG
	  i = be - 1 - i;
	  for (j = 0; j < nedges - i; j++)
	    m[mn][j] = I;
	  for (; j < nedges; j++)
	    m[mn][j] = WR;
	  m[mn++][j] = END;
	  int oldedges[nedges];
	  memcpy(oldedges, edges, nedges * sizeof(int));
	  for (j = 0; j < i; j++)
	    edges[j] = oldedges[nedges - i + j];
	  for (; j < nedges; j++)
	    edges[j] = oldedges[j - i];
	  memcpy(oldedges, edgepos, be * sizeof(int));
	  for (j = 0; j < i; j++)
	    edgepos[j] = j;//oldedges[be - i + j];
	  for (; j < be; j++)
	    edgepos[j] = oldedges[j - i] + i;
	  bestedge += i;
	//DEBUG:
	/*printf("after WR: ");
	for (j = 0; j < nedges; j++)
	  printf("%d ", edges[j]);
	  printf("\n");*/
	//END DEBUG
	}
      }
      /*printf("%d: ", bestedge);
      for (i = 0; i < be; i++)
	printf("%d ", edgepos[i]);
	printf("\n");*/
      // now, move all edges in edgepos toward edgepos[bestedge]
      for (i = bestedge + 1; i < be; i++) // start to the right
	for (; edgepos[i] != edgepos[i - 1] + 1; edgepos[i]--)
	  VSWAP(edgepos[i] - 1);
      for (i = bestedge - 1; i >= 0; i--) // now to the left
	for (; edgepos[i] != edgepos[i + 1] - 1; edgepos[i]++)
	  VSWAP(edgepos[i]);
      // see if virtual crossings are still needed
      for (j = 0; j < 4; j++)
	if (p.crossings[best][j] == edgepos[0])
	  break; // now j is the starting index to use for the crossing
      for (i = 0; i < be; i++)
	if (edges[edgepos[i]] != p.crossings[best][(j + 4 - i) % 4]) {
	  bv = 2; // more virtual crossings still needed
	  break;
	}
    }
    for (i = 0; i < nedges; i++) // find where the edges start
      for (j = 0; j < 4; j++)
	if (edges[i] == p.crossings[best][j])
	  goto rof; // "double break"
  rof:
    if (bv == 2) { // the needed edges are together, but in the wrong order
      // arrange the crossing (only one way is allowed unless be == 4)
      if (be < 4) {
	int cedges[be]; // edges of the crossing which connect above
	for (k = 0; k < be; k++)
	  for (j = 0; j < 4; j++)
	    if (edges[i + k] == p.crossings[best][j]) {
	      cedges[k] = j;
	      break;
	    }
	if (be == 2 && abs(cedges[1] - cedges[0]) == 2) { // special case
	  j = cedges[0];
	  x2ivj = 1;
	} else {
	  // now find some edge which doesn't connect above
	  for (j = 0; j < 4; j++) {
	    int found = 0;
	    for (k = 0; k < be; k++)
	      if (cedges[k] == j)
		found = 1;
	    if (found == 0)
	      break;
	  }
	  // work backward until j reaches an edge which does connect
	  for (; ; j = (j + 3) % 4) { // for debugging, look for infinite loop
	    int found = 0;
	    for (k = 0; k < be; k++)
	      if (cedges[k] == j)
		found = 1;
	    if (found == 1)
	      break;
	  }
	}
      } else { // be == 4
	int bestj, least = 10;
	for (j = 0; j < 4; j++) { // different starting locations
	  int worst = 0, l;
	  for (k = 0; k < 4; k++)
	    for (l = 0; l < 4; l++)
	      if (p.crossings[best][(j - k + 4) % 4] == edges[i + l]) {
		if (abs(l - k) > worst)
		  worst = abs(l - k);
		break;
	      }
	  if (worst < least) {
	    bestj = j;
	    least = worst;
	  }
	}
	j = bestj;
      }
      if (!x2ivj) {
	// now, j is at the start of the crossing's connecting edges
	// sweep through the edges of the crossing, find its matching edge
	       // and bring the edge to where it belongs
	//DEBUGGING:
	/*for (k = 0; k < nedges; k++)
	  printf("%d ", edges[k]);
	  printf("\n");*/
	//END DEBUGGING
	
	for (k = 0; k < be; k++) {
	  int l;
	  for (l = 0; l < be; l++)
	    if (p.crossings[best][(j - k + 4) % 4] == edges[i + l]) {
	      int a;
	      for (a = i + l - 1; a >= i + k; a--)
		VSWAP(a);
	    }
	}
	
	//DEBUGGING:
	/*for (k = 0; k < nedges; k++)
	  printf("%d ", edges[k]);
	  printf("\n");*/
	//END DEBUGGING
      
      }
    }
    // done re-arrangement (if it was necessary)
    for (k = 0; k < i; k++)
      m[mn][k] = I;
    if (x2ivj)
      m[mn][k++] = (j % 2 == 0) ? X2UV1 : X2OV1;
    else
      m[mn][k++] = 2 * be + 1 - j % 2;
    for (; k + be - 1 < nedges; k++)
      m[mn][k] = I;
    m[mn][k] = END;
    //m[mn] = realloc(m[mn], (k + 1) * sizeof(move));
    if (be < 2) // make room
      for (k = nedges - 1; k >= i + be; k--)
	  edges[k + 4 - 2 * be] = edges[k];
    if (x2ivj) {
      edges[i] = p.crossings[best][(j + 3) % 4];
      edges[i + 1] = p.crossings[best][(j + 1) % 4];
    } else
      for (k = 0; k < 4 - be; k++)
	edges[i + k] = p.crossings[best][(j + 1 + k) % 4];
    if (be > 2) // fill the void
      for (k = i + be; k < nedges; k++)
	edges[k + 4 - 2 * be] = edges[k];
    nedges += 4 - 2 * be;
    mn++;
    used[best] = 1;
  }
  m[mn][0] = END;

  // make m more compact
  // working top to bottom, moving items up if possible
  // making several passes until done
  // special cases: X02 + W(L|R) --> X01; X2iV1 + V --> X2iV2

  int changed;
  do { 
    changed = 0;
    for (i = 1; i < mn; i++) {
      int x = 0, y = 0; // position along ith (x), (i-1)th (y) row
      k = 0; // corresponding index along (i-1)th row
      for (j = 0; m[i][j] != END; j++) {
	if (j > 0)
	  x += abovemovesize(m[i][j - 1]);
	while (x > y && m[i - 1][k] != END)
	  y += belowmovesize(m[i - 1][k++]);
	while (belowmovesize(m[i - 1][k]) == 0)
	  k++;
	// TODO: special cases
	if (x == y && m[i][j] != I) { // check for space above
	  int l, space = 1;
	  for (l = 0; l < abovemovesize(m[i][j]); l++)
	    if (m[i - 1][k + l] != I) {
	      space = 0;
	      break;
	    }
	  int end;
	  if (space) {
	    for (end = 0; m[i - 1][end] != END; end++);
	    /*for (l = 0; l < x + abovemovesize(m[i][j]); l++)
	      if (m[i - 1][end - l] == WR) {
		space = 0;
		break;
		}*/
	    if (m[i - 1][end - 1] == WR)
	      space = 0;
	  }
	  if (m[i][j] == WR && m[i][j + 1] != END)
	    space = 0;
	  if (space) { // move m[i][j] up
	    m[i - 1][k] = m[i][j];
	    int a;
	    l = abovemovesize(m[i][j]) - 1;
	    for (a = k + 1; m[i - 1][a + l - 1] != END; a++) // shift left
	      m[i - 1][a] = m[i - 1][a + l];
	    
	    l = belowmovesize(m[i][j]) - 1;
	    if (m[i][j] == WL) {
	      for (a = j; m[i][a + 1] != END; a++)
		m[i][a] = m[i][a + 1];
	      m[i][a] = I;
	    } else if (m[i][j] == WR) {
	      for (a = j; a > 0; a--)
		m[i][a] = m[i][a - 1];
	      m[i][0] = I;
	    } else if (l < 0) // belowmovesize == 0; shift left
	      for (a = j; m[i][a] != END; a++)
		m[i][a] = m[i][a + 1];
	    else if (l > 0) { // shift right
	      for (a = j; m[i][a] != END; a++); // find the end
	      for (; a > j; a--)
		m[i][a + l] = m[i][a];
	    }
	    for (a = 0; a <= l; a++)
	      m[i][j + a] = I;
	    
	    changed = 1;
	  } else if (j == 0 && m[i][0] == WL && k == 0
		     && (m[i - 1][0] == X02 || m[i - 1][0] == X01)
		     && m[i - 1][1] == END) {
	    m[i - 1][0] = m[i - 1][0] == X02 ? X01 : X02;
	    int a;
	    for (a = 0; m[i][a + 1] != END; a++)
	      m[i][a] = m[i][a + 1];
	    m[i][a] = I;
	    changed = 1;
	  } else if (m[i][j] == V && (m[i - 1][k] == X2OV1 ||
				      m[i - 1][k] == X2OV2 ||
				      m[i - 1][k] == X2UV1 ||
				      m[i - 1][k] == X2UV2)) {
	    if (m[i - 1][k] % 2 == 0) // X2iV1
	      m[i - 1][k]++;
	    else
	      m[i - 1][k]--;
	    int a;
	    for (a = j; m[i][a] != END; a++);
	    for (; a > j; a--)
	      m[i][a + 1] = m[i][a];
	    m[i][j] = m[i][j + 1] = I;
	    changed = 1;
	  }
	} else if (m[i][j] == WR && m[i][j + 1] == END
		   && (m[i - 1][0] == X02 || m[i - 1][0] == X01)
		   && m[i - 1][1] == END) {
	  m[i - 1][0] = m[i - 1][0] == X02 ? X01 : X02;
	  int a = j;
	  m[i][j] = END;
	  for (; a >= 0; a--)
	    m[i][a + 1] = m[i][a];
	  m[i][0] = I;
	  changed = 1;
	} 
      }
    }
  } while (changed);
  // the END should have been moved up as necessary

  for (i = 0; m[i][0] != END; i++) {
    for (j = 0; m[i][j] != END; j++);
    m[i] = realloc(m[i], (j + 1) * sizeof(move));
  }
  m[i] = realloc(m[i], sizeof(move));
  i++;
  mn = i;
  for (; i < 10 * p.n; i++)
    free(m[i]);
  m = realloc(m, mn * sizeof(move *));

  return m;
}

int abovemovesize(move m) {
  switch (m) {
  case WL:
  case WR:
  case I:
    return 1;
  case V:
  case X2OV1:
  case X2OV2:
  case X2UV1:
  case X2UV2:
    return 2;
  default:
    return m / 2;
  }
}

int belowmovesize(move m) {
  switch(m) {
  case WL:
  case WR:
    return 0;
  case I:
    return 1;
  case V:
  case X2OV1:
  case X2OV2:
  case X2UV1:
  case X2UV2:
    return 2;
  default:
    return 4 - m / 2;
  }
}

void freemoves(move **m) {
  int i;
  for (i = 0; m[i][0] != END; i++)
    free(m[i]);
  free(m[i]);
  free(m);
}

void printmoves(move **m) {
  int i, j;
  for (i = 0; m[i][0] != END; i++) {
    for (j = 0; m[i][j] != END; j++)
      switch(m[i][j]) {
      case I:
	printf("I ");
	break;
      case V:
	printf("V ");
	break;
      case WL:
	printf("WL ");
	break;
      case WR:
	printf("WR ");
	break;
      case X2OV1:
      case X2OV2:
      case X2UV1:
      case X2UV2:
	printf("X2%sV%d ", (m[i][j] / 2) % 2 == 1 ? "O":"U", m[i][j] % 2 + 1);
	break;
      default:
	printf("X%d%d ", m[i][j] / 2, m[i][j] % 2 + 1);
      }
    printf("\n");
  }
}


#define LINE fprintf(f, "%d setlinewidth 0 setgray 1 setlinecap\n", lw)
#define WHITE fprintf(f, "%d setlinewidth 1 setgray 0 setlinecap\n", 3 * lw)
#define MOVETO "%f %f moveto\n"
#define CURVETO "%f %f %f %f %f %f curveto stroke\n"

void drawPS(FILE *f, code c, int drawcode, int showpage) {
  ldrawPS(f, c, drawcode, showpage, 5);
}

void ldrawPS(FILE *f, code c, int drawcode, int showpage, int lw) {
  PD pd = code2PD(c);
  move **m = layout(pd);
  freePD(pd);
  double w = 500, h = 500;
  fprintf(f, "%%!PS-Adobe-3.0 EPSF-3.0\n");
  fprintf(f, "%%%%BoundingBox: 0 0 %f %f\n\n", w, h);
  fprintf(f, "gsave\n");
  if (m[0][0] == C) {
    LINE;
    fprintf(f, "%f %f %f 0 360 arc stroke\ngrestore\n%s%%%%EOF\n",
	    w / 2, h / 2, h < w ? 3 * h / 8 : 3 * w / 8,
	    showpage ? "showpage\n" : "");
    freemoves(m);
    return;
  }

  int nrows;
  for (nrows = 0; m[nrows][0] != END; nrows++);

  int maxrow = 0, rowsize[nrows], i, j, nwrap = 0;
  for (i = 0; i < nrows; i++) {
    rowsize[i] = 0;
    for (j = 0; m[i][j] != END; j++) {
      if (m[i][j] == WL || m[i][j] == WR)
	nwrap++;
      rowsize[i] += abovemovesize(m[i][j]);
    }
    if (rowsize[i] > maxrow)
      maxrow = rowsize[i];
  }
  double realh = h, rowh;
  h -= 15 * nwrap;
  if (drawcode)
    rowh = (h - 30) / nrows;
  else
    rowh = h / nrows;
  rowsize[i] = 0;
  double xpos[maxrow];

  // draw under strands first, then over strands thick in white
  // then over strands
  for (i = 0; i < nrows; i++) {
    if (i == 0) {
      for (j = 0; j < 4; j++)
	xpos[j] = w / 8 + j * w / 4;
      int o, u;
      if (m[0][0] == X02) {
	o = 1;
	u = 0;
      } else {
	o = 0;
	u = 1;
      }
      LINE;
      fprintf(f, MOVETO, xpos[u], h - rowh);
      fprintf(f, CURVETO, xpos[u], h, xpos[u + 2], h, xpos[u + 2], h - rowh);
      WHITE;
      fprintf(f, MOVETO, xpos[o], h - rowh);
      fprintf(f, CURVETO, xpos[o], h, xpos[o + 2], h, xpos[o + 2], h - rowh);
      LINE;
      fprintf(f, MOVETO, xpos[o], h - rowh);
      fprintf(f, CURVETO, xpos[o], h, xpos[o + 2], h, xpos[o + 2], h - rowh);
      continue;
    }
    double newpos[rowsize[i + 1]];
    for (j = 0; j < rowsize[i + 1]; j++)
      newpos[j] = w / (2 * rowsize[i + 1]) + j * w / rowsize[i + 1];
    int a = 0, b = 0; // indices into xpos (a) and newpos (b)
    for (j = 0; m[i][j] != END; j++);
    j--;
    for (; m[i][j] == WR; j--)
      b++;
    for (j = 0; m[i][j] != END; j++) {
      int o = 0;
      LINE;
      switch(m[i][j]) {
      case I:
	fprintf(f, MOVETO, xpos[a], h - i * rowh);
	fprintf(f, CURVETO, xpos[a], h - (i + 0.25) * rowh, newpos[b],
		h - (i + 0.75) * rowh, newpos[b], h - (i + 1) * rowh);
	a++;
	b++;
	break;
      case X11:
      case X12:
	o = m[i][j] % 2;
	if (o == 1) {
	  fprintf(f, MOVETO, xpos[a], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a], h - (i + 0.25) * rowh, newpos[b + 1],
		  h - (i + 0.75) * rowh, newpos[b + 1], h - (i + 1) * rowh);
	} else {
	  fprintf(f, MOVETO, newpos[b], h - (i + 1) * rowh);
	  fprintf(f, CURVETO, newpos[b], h - i * rowh, newpos[b + 2],
		  h - i * rowh, newpos[b + 2], h - (i + 1) * rowh);
	}
	WHITE;
	if (o == 1) {
	  fprintf(f, MOVETO, newpos[b], h - (i + 1) * rowh);
	  fprintf(f, CURVETO, newpos[b], h - i * rowh, newpos[b + 2],
		  h - i * rowh, newpos[b + 2], h - (i + 1) * rowh);
	} else {
	  fprintf(f, MOVETO, xpos[a], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a], h - (i + 0.25) * rowh, newpos[b + 1],
		  h - (i + 0.75) * rowh, newpos[b + 1], h - (i + 1) * rowh);
	}
	LINE;	  
	if (o == 1) {
	  fprintf(f, MOVETO, newpos[b], h - (i + 1) * rowh);
	  fprintf(f, CURVETO, newpos[b], h - i * rowh, newpos[b + 2],
		  h - i * rowh, newpos[b + 2], h - (i + 1) * rowh);
	} else {
	  fprintf(f, MOVETO, xpos[a], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a], h - (i + 0.25) * rowh, newpos[b + 1],
		  h - (i + 0.75) * rowh, newpos[b + 1], h - (i + 1) * rowh);
	}
	a++;
	b += 3;
	break;
      case X21:
      case X22:
      case V:
	o = m[i][j] % 2;
	fprintf(f, MOVETO, xpos[a + 1 - o], h - i * rowh);
	fprintf(f, CURVETO, xpos[a + 1 - o], h - (i + 0.25) * rowh,
		newpos[b + o], h - (i + 0.75) * rowh,
		newpos[b + o], h - (i + 1) * rowh);
	if (m[i][j] != V) {
	  WHITE;
	  fprintf(f, MOVETO, xpos[a + o], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a + o], h - (i + 0.25) * rowh,
		  newpos[b + 1 - o], h - (i + 0.75) * rowh, newpos[b + 1 - o],
		  h - (i + 1) * rowh);
	  LINE;
	} else {
	  double s, x, y;
	  s = (rowh - rowh / (xpos[a + 1] - newpos[b]) * (xpos[a] - newpos[b]))
	    / (rowh/(xpos[a + 1]-newpos[b])*(newpos[b + 1]-xpos[a]) + rowh);
	  x = xpos[a] + s * (newpos[b + 1] - xpos[a]);
	  y = h - (i + s) * rowh;
	  fprintf(f, "%f %f %d 0 360 arc stroke\n", x, y, 3 * lw);
	}
	fprintf(f, MOVETO, xpos[a + o], h - i * rowh);
	fprintf(f, CURVETO, xpos[a + o], h - (i + 0.25) * rowh,
		newpos[b + 1 - o], h - (i + 0.75) * rowh, newpos[b + 1 - o],
		h - (i + 1) * rowh);
	a += 2;
	b += 2;
	break;
      case X2OV1:
      case X2OV2:
	o = 1;
      case X2UV1:
      case X2UV2:
	if (o) {
	  fprintf(f, MOVETO, newpos[b], h - (i + 1) * rowh);
	  fprintf(f, CURVETO, newpos[b], h - i * rowh, newpos[b + 1],
		  h - i * rowh, newpos[b + 1], h - (i + 1) * rowh);
	} else {
	  fprintf(f, MOVETO, xpos[a], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a], h - (i + 1) * rowh, xpos[a + 1],
		  h - (i + 1) * rowh, xpos[a + 1], h - i * rowh);
	}
	fprintf(f, "gsave\n");
	WHITE;
	if (m[i][j] % 2 == 1) // X2iV2
	  fprintf(f, "%f %f moveto %f %f lineto %f %f lineto %f %f lineto "
		  "closepath clip newpath\n", newpos[b], h - (i + 1) * rowh,
		  (newpos[b] + newpos[b + 1])/2, h - (i + 1) * rowh,
		  (xpos[a] + xpos[a + 1])/2, h - i * rowh,
		  xpos[a], h - i * rowh);
	else // X2iV1
	  fprintf(f, "%f %f moveto %f %f lineto %f %f lineto %f %f lineto "
		  "closepath clip newpath\n", (newpos[b] + newpos[b + 1])/2,
		  h - (i + 1) * rowh, newpos[b + 1], h - (i + 1) * rowh,
		  xpos[a + 1], h - i * rowh, (xpos[a] + xpos[a + 1])/2,
		  h - i * rowh);
	if (o) {
	  fprintf(f, MOVETO, xpos[a], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a], h - (i + 1) * rowh, xpos[a + 1],
		  h - (i + 1) * rowh, xpos[a + 1], h - i * rowh);
	} else {
	  fprintf(f, MOVETO, newpos[b], h - (i + 1) * rowh);
	  fprintf(f, CURVETO, newpos[b], h - i * rowh, newpos[b + 1],
		  h - i * rowh, newpos[b + 1], h - (i + 1) * rowh);
	}
	fprintf(f, "grestore\n");
	if (o) {
	  fprintf(f, MOVETO, xpos[a], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a], h - (i + 1) * rowh, xpos[a + 1],
		  h - (i + 1) * rowh, xpos[a + 1], h - i * rowh);
	} else {
	  fprintf(f, MOVETO, newpos[b], h - (i + 1) * rowh);
	  fprintf(f, CURVETO, newpos[b], h - i * rowh, newpos[b + 1],
		  h - i * rowh, newpos[b + 1], h - (i + 1) * rowh);
	}
	if (m[i][j] % 2 == 0) // should use better method for locating V. Xing
	  fprintf(f, "%f %f %d 0 360 arc stroke\n",
		  (7 * xpos[a] + xpos[a + 1]) / 8, h - (i + 0.5) * rowh,
		  3 * lw);
	else
	  fprintf(f, "%f %f %d 0 360 arc stroke\n",
		  (xpos[a] + 7 * xpos[a + 1]) / 8, h - (i + 0.5) * rowh,
		  3 * lw);
	a += 2;
	b += 2;
	break;
      case X31:
      case X32:
	o = m[i][j] % 2;
	if (o == 0) {
	  fprintf(f, MOVETO, xpos[a + 1], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a + 1], h - (i + 0.25) * rowh, newpos[b],
		  h - (i + 0.75) * rowh, newpos[b], h - (i + 1) * rowh);
	} else {
	  fprintf(f, MOVETO, xpos[a], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a], h - (i + 1) * rowh, xpos[a + 2],
		  h - (i + 1) * rowh, xpos[a + 2], h - i * rowh);
	}
	WHITE;
	if (o == 0) {
	  fprintf(f, MOVETO, xpos[a], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a], h - (i + 1) * rowh, xpos[a + 2],
		  h - (i + 1) * rowh, xpos[a + 2], h - i * rowh);
	} else {
	  fprintf(f, MOVETO, xpos[a + 1], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a + 1], h - (i + 0.25) * rowh, newpos[b],
		  h - (i + 0.75) * rowh, newpos[b], h - (i + 1) * rowh);
	}
	LINE;
	if (o == 0) {
	  fprintf(f, MOVETO, xpos[a], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a], h - (i + 1) * rowh, xpos[a + 2],
		  h - (i + 1) * rowh, xpos[a + 2], h - i * rowh);
	} else {
	  fprintf(f, MOVETO, xpos[a + 1], h - i * rowh);
	  fprintf(f, CURVETO, xpos[a + 1], h - (i + 0.25) * rowh, newpos[b],
		  h - (i + 0.75) * rowh, newpos[b], h - (i + 1) * rowh);
	}
	a += 3;
	b++;
	break;
      case X41:
      case X42:
	o = m[i][j] % 2;
	fprintf(f, MOVETO, xpos[a + 1 - o], h - i * rowh);
	fprintf(f, CURVETO, xpos[a + 1 - o], h - (i + 1) * rowh,
		xpos[a + 3 - o], h - (i + 1) * rowh, xpos[a + 3 - o],
		h - i * rowh);
	WHITE;
	fprintf(f, MOVETO, xpos[a + o], h - i * rowh);
	fprintf(f, CURVETO, xpos[a + o], h - (i + 1) * rowh, xpos[a + 2 + o],
		h - (i + 1) * rowh, xpos[a + 2 + o], h - i * rowh);
	LINE;
	fprintf(f, MOVETO, xpos[a + o], h - i * rowh);
	fprintf(f, CURVETO, xpos[a + o], h - (i + 1) * rowh, xpos[a + 2 + o],
		h - (i + 1) * rowh, xpos[a + 2 + o], h - i * rowh);
	a += 4;
	break;
      case WL:
	fprintf(f, MOVETO, xpos[a], h - i * rowh);
	fprintf(f, CURVETO, xpos[a], h - (i + 0.75) * rowh, xpos[a] / 3, h,
		xpos[a], h);
	double x1 = newpos[rowsize[i + 1] - 1];
	double x2 = (2 * w + newpos[rowsize[i + 1] - 1]) / 3;
	fprintf(f, MOVETO, xpos[a], h);
	fprintf(f, CURVETO, xpos[a], h, x1, h, x1, h);
	fprintf(f, MOVETO, x1, h);
	fprintf(f, CURVETO, x2, h, x2, h - i * rowh, x2, h - i * rowh);
	fprintf(f, MOVETO, x2, h - i * rowh);
	fprintf(f, CURVETO, x2, h - (i + 0.25) * rowh,
		x1, h - (i + 0.75) * rowh, x1, h - (i + 1) * rowh);
	a++;
	break;
      case WR:
	fprintf(f, MOVETO, xpos[a], h - i * rowh);
	double x = (2 * w + xpos[a]) / 3;
	fprintf(f, CURVETO, xpos[a], h - (i + 0.75) * rowh, x, h, xpos[a], h);
	fprintf(f, MOVETO, xpos[a], h);
	fprintf(f, CURVETO, xpos[a], h, newpos[0], h, newpos[0], h);
	fprintf(f, MOVETO, newpos[0], h);
	fprintf(f, CURVETO, newpos[0] / 3, h, newpos[0] / 3, h - i * rowh,
		newpos[0] / 3, h - i * rowh);
	fprintf(f, MOVETO, newpos[0] / 3, h - i * rowh);
	fprintf(f, CURVETO, newpos[0] / 3, h - (i + 0.25) * rowh, newpos[0],
		h - (i + 0.75) * rowh, newpos[0], h - (i + 1) * rowh);
	a++;
	break;
      default:
	fprintf(stderr, "Unimplemented move: %d\n", m[i][j]);
      }
    }
    memcpy(xpos, newpos, rowsize[i + 1] * sizeof(double));
  }
  freemoves(m);

  if (drawcode) {
    char *s = sprintcode(c);
    fprintf(f, "/Helvetica findfont 30 scalefont setfont 0 0 moveto\n");
    fprintf(f, "(%s) show\n", s);
    free(s);
  }
  fprintf(f, "grestore\n\n");
  if (showpage)
    fprintf(f, "showpage\n");
  fprintf(f, "%%%%EOF\n");
}

void drawPNG(char *filename, code c, int xres, int yres) {
  char cmdname[1024];
  snprintf(cmdname, 1023, "gs -q -sDEVICE=pnggray -dBATCH -dNOPAUSE -r288 -g2000x2000 -sOutputFile=- - | convert -transparent white -resize %dx%d - %s",
	   xres, yres, filename);
  FILE *f = popen(cmdname, "w");
  if (xres > 100)
    drawPS(f, c, 0, 1);
  else
    ldrawPS(f, c, 0, 1, 10);
  pclose(f);
}
