#include <stdlib.h>
#include <stdio.h>
#include "gauss.h"
#include "moves.h"
#include "pd.h"
#include "draw.h"

int main(int argc, char *argv[]) {
  if (argc < 3) {
    printf("Usage: genlowest <max crossings> <number of crossings for output> [0 for non-cyclic] [1 for reversible]\n");
    return 0;
  }
  int sz = atoi(argv[1]);
  int maxp = atoi(argv[2]);
  cyclic = (argc >= 4 ? atoi(argv[3]) : 1);
  reversible = (argc == 5 ? atoi(argv[4]) : 0);
  initcrossings(sz);
  int n;
  code *codes = genallcodes(maxp, &n);
  //int *lowest = findlowest(codes, n, sz);
  //initlowest(FILENAME, 0);
  initlowest(sz);
  n <<= sz - maxp;

  int i, m = 0, j = 0;
  for (i = 0; i < n; i++) {
    if (getlowest(i) == -1) {
      code c = getcode(codes, sz, i);
      if (c.n != -1) {
	if (c.n <= maxp) {
	  j++;
	  char filename[32];
	  snprintf(filename, 31, "images/%d.eps", i);
	  FILE *f = fopen(filename, "w");
	  //PD p = code2PD(c);
	  //move **mov = layout(p);
	  drawPS(f, c, 1, 1);
	  //freePD(p);
	  //freemoves(mov);
	  fclose(f);
	}
	free(c.code);
      }
    }
  }
  printf("Number of unique codes: %d\n", j);
  return 0;
}
