#include <stdlib.h>
#include <stdio.h>
#include "gauss.h"
#include "moves.h"
//#include "poly.h"

int pcompare(const void *a, const void *b) {
  return compare(*((code *) a), *((code *) b));
}

int main(int argc, char *argv[]) {
  if (argc < 3) {
    printf("Usage: formatlist <max crossings> <number of crossings for input> [0 for non-cyclic] [1 for reversible]\n");
    return 0;
  }
  int sz = atoi(argv[1]);
  int maxp = atoi(argv[2]);
  cyclic = (argc >= 4 ? atoi(argv[3]) : 1);
  reversible = (argc == 5 ? atoi(argv[4]) : 0);
  initcrossings(15 * sz);
  //initpascal(17 * sz);
  knot n;
  code *codes = genallcodes(maxp, &n);
  //int *lowest = findlowest(codes, n, sz);
  //findlowest(codes, n, sz);
  //initlowest(FILENAME, 0);
  initlowest(sz);
  code input[n];
  n <<= sz - maxp;

  knot i = 0, m = 0, j = 0;
  char line[1024];
  while (scanf("%s\n", line) != EOF) {
    code c = parsecode(line);
    code f = first(c);
    if (f.code != c.code)
      free(c.code);
    input[i++] = f; // will do for now
  }
  qsort(input, i, sizeof(code), pcompare);

  for (j = 0; j < i; j++)
    printcode(input[j]);

/*   for (i = 0; i < n; i++) { */
/*     code c = getcode(codes, sz, i); */
/*     if (c.n != -1) { */
/*       if (c.n <= maxp) { */
/* 	j++; */
/* 	knot l = getlowest(i); */
/* 	if (l == -1) { //lowest[i] == -1) { */
/* 	  printf("*%d*\t", i); */
/* 	  m++; */
/* 	} else */
/* 	  printf("%d\t", l); //lowest[i]); */
/* 	/\*poly p = multijonespoly(c, 3); */
/* 	  printpoly(p); */
/* 	  printf(" \t"); */
/* 	  free(p.coeffs);*\/ */
/* 	/\*twopoly tp = genalexander(c); */
/* 	printtwopoly(tp); */
/* 	printf(" \t"); */
/* 	freetwopoly(tp);*\/ */
/* 	//printf("%d ", Jinvar(c)); */
/* 	printcode(c); */
/*       } */
/*       free(c.code); */
/*     } */
/*   } */
  printf("Number of codes: " KNOT_PRINTF "\n", i);

  return 0;
}
